import processing.core.*; 
import processing.xml.*; 

import ddf.minim.*; 
import javax.swing.ImageIcon; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class this_is_your_dream extends PApplet {




String picFile_Start = "start.png";
String picFile_Title = "title.png";
String picFile_Help = "press_esc.png";
String picFile_Fail = "failure.png";
String picFile_Success = "success.png";
String picFile_buttonStartB = "button_start_b.png";
String picFile_buttonStartD = "button_start_d.png";
String picFile_buttonStartR = "button_start_r.png";
String picFile_buttonNewGameB = "button_new_game_b.png";
String picFile_buttonNewGameD = "button_new_game_d.png";
String picFile_buttonNewGameR = "button_new_game_r.png";
String picFile_buttonNextGameB = "button_next_game_b.png";
String picFile_buttonNextGameD = "button_next_game_d.png";
String picFile_buttonNextGameR = "button_next_game_r.png";
String picFile_Lvl1 = "level1.png";
String picFile_buttonLvl1B = "button_lvl1_b.png";
String picFile_buttonLvl1D = "button_lvl1_d.png";
String picFile_buttonLvl1R = "button_lvl1_r.png";
String picFile_Lvl2 = "level2.png";
String picFile_buttonLvl2B = "button_lvl2_b.png";
String picFile_buttonLvl2D = "button_lvl2_d.png";
String picFile_buttonLvl2R = "button_lvl2_r.png";
String picFile_Lvl3 = "level3.png";
String picFile_buttonLvl3B = "button_lvl3_b.png";
String picFile_buttonLvl3D = "button_lvl3_d.png";
String picFile_buttonLvl3R = "button_lvl3_r.png";
String picFile_Lvl4 = "level4.png";
String picFile_buttonLvl4B = "button_lvl4_b.png";
String picFile_buttonLvl4D = "button_lvl4_d.png";
String picFile_buttonLvl4R = "button_lvl4_r.png";
String picFile_Lvl5 = "level5.png";
String picFile_buttonLvl5B = "button_lvl4_b.png";
String picFile_buttonLvl5D = "button_lvl4_d.png";
String picFile_buttonLvl5R = "button_lvl4_r.png";
String picFile_Lvl6 = "level6.png";
String picFile_buttonLvl6B = "button_lvl4_b.png";
String picFile_buttonLvl6D = "button_lvl4_d.png";
String picFile_buttonLvl6R = "button_lvl4_r.png";
String picFile_Lvl7 = "level7.png";
String picFile_Lvl8 = "level8.png";
String picFile_Lvl9 = "level9.png";

int SCREEN_START = 0;
int SCREEN_LVL1 = 1;
int SCREEN_LVL2 = 2;
int SCREEN_LVL3 = 3;
int SCREEN_LVL4 = 4;
int SCREEN_LVL5 = 5;
int SCREEN_LVL6 = 6;
int SCREEN_LVL7 = 7;
int SCREEN_LVL8 = 8;
int SCREEN_LVL9 = 9;
int SCREEN_FAIL = -7447;
int SCREEN_WIN = 7447;

PImage bkg_Start;
PImage bkg_Title;
PImage bkg_Help;
PImage bkg_Fail;
PImage bkg_Success;
PImage bkg_Lvl1;
PImage bkg_Lvl2;
PImage bkg_Lvl3;
PImage bkg_Lvl4;
PImage bkg_Lvl5;
PImage bkg_Lvl6;
PImage bkg_Lvl7;
PImage bkg_Lvl8;
PImage bkg_Lvl9;

ImageButtons button_Start;
ImageButtons button_NewGame;
ImageButtons button_NextGame;
ImageButtons button_Lvl1;
ImageButtons button_Lvl2;
ImageButtons button_Lvl3;
ImageButtons button_Lvl4;
ImageButtons button_Lvl5;
ImageButtons button_Lvl6;
ImageButtons button_Lvl7;
ImageButtons button_Lvl8;
ImageButtons button_Lvl9;

int dreamStatus = SCREEN_START;
int lvl1MilSecs = 5000;
int stepSeconds = lvl1MilSecs;
int milSecs = 0;
Minim minim;
AudioPlayer playerHaukotus;
AudioPlayer playerHuohotus;
AudioPlayer playerWakeup;
PFont fontti;

public void setup() {
  frame.setTitle("This is your dream - Ludum Dare 21");
  ImageIcon titlebaricon = new ImageIcon(loadBytes("icon_dream.gif"));
  frame.setIconImage(titlebaricon.getImage());
  size(800, 600);
  smooth();
  
  minim = new Minim(this);
  playerHaukotus = minim.loadFile("haukotus.wav");
  playerHuohotus = minim.loadFile("huohotus.wav");
  playerWakeup = minim.loadFile("piippaus.wav");
  
  fontti = loadFont("Eatyourface-48.vlw");

  bkg_Start = loadImage(picFile_Start);
  bkg_Title = loadImage(picFile_Title);
  bkg_Help = loadImage(picFile_Help);
  bkg_Fail = loadImage(picFile_Fail);
  bkg_Success = loadImage(picFile_Success);
  bkg_Lvl1 = loadImage(picFile_Lvl1);
  bkg_Lvl2 = loadImage(picFile_Lvl2);
  bkg_Lvl3 = loadImage(picFile_Lvl3);
  bkg_Lvl4 = loadImage(picFile_Lvl4);
  bkg_Lvl5 = loadImage(picFile_Lvl5);
  bkg_Lvl6 = loadImage(picFile_Lvl6);
  bkg_Lvl7 = loadImage(picFile_Lvl7);
  bkg_Lvl8 = loadImage(picFile_Lvl8);
  bkg_Lvl9 = loadImage(picFile_Lvl9);

  PImage button_StartB = loadImage(picFile_buttonStartB);
  PImage button_StartD = loadImage(picFile_buttonStartD);
  PImage button_StartR = loadImage(picFile_buttonStartR);
  int x_button_Start = 630;
  int y_button_Start = 30;
  int w_button_Start = button_StartB.width/2;
  int h_button_Start = button_StartB.height/2;  
  button_Start = new ImageButtons(x_button_Start, y_button_Start, w_button_Start, h_button_Start, button_StartB, button_StartR, button_StartD);
  
  PImage button_NewGameB = loadImage(picFile_buttonNewGameB);
  PImage button_NewGameD = loadImage(picFile_buttonNewGameD);
  PImage button_NewGameR = loadImage(picFile_buttonNewGameR);
  int x_button_NewGame = 0;
  int y_button_NewGame = 0;
  int w_button_NewGame = button_NewGameB.width/2;
  int h_button_NewGame = button_NewGameB.height/2;  
  button_NewGame = new ImageButtons(x_button_NewGame, y_button_NewGame, w_button_NewGame, h_button_NewGame, button_NewGameB, button_NewGameR, button_NewGameD);
  
  PImage button_NextGameB = loadImage(picFile_buttonNextGameB);
  PImage button_NextGameD = loadImage(picFile_buttonNextGameD);
  PImage button_NextGameR = loadImage(picFile_buttonNextGameR);
  int x_button_NextGame = 0;
  int y_button_NextGame = 0;
  int w_button_NextGame = button_NextGameB.width/2;
  int h_button_NextGame = button_NextGameB.height/2;  
  button_NextGame = new ImageButtons(x_button_NextGame, y_button_NextGame, w_button_NextGame, h_button_NextGame, button_NextGameB, button_NextGameR, button_NextGameD);

  PImage button_Lvl1B = loadImage(picFile_buttonLvl1B);
  PImage button_Lvl1D = loadImage(picFile_buttonLvl1D);
  PImage button_Lvl1R = loadImage(picFile_buttonLvl1R);
  int x_button_Lvl1 = 250;
  int y_button_Lvl1 = 100;
  int w_button_Lvl1 = button_Lvl1B.width;
  int h_button_Lvl1 = button_Lvl1B.height;  
  button_Lvl1 = new ImageButtons(x_button_Lvl1, y_button_Lvl1, w_button_Lvl1, h_button_Lvl1, button_Lvl1B, button_Lvl1R, button_Lvl1D);
  
  PImage button_Lvl2B = loadImage(picFile_buttonLvl2B);
  PImage button_Lvl2D = loadImage(picFile_buttonLvl2D);
  PImage button_Lvl2R = loadImage(picFile_buttonLvl2R);
  int x_button_Lvl2 = 0;
  int y_button_Lvl2 = 100;
  int w_button_Lvl2 = button_Lvl2B.width;
  int h_button_Lvl2 = button_Lvl2B.height;  
  button_Lvl2 = new ImageButtons(x_button_Lvl2, y_button_Lvl2, w_button_Lvl2, h_button_Lvl2, button_Lvl2B, button_Lvl2R, button_Lvl2D);
  
  PImage button_Lvl3B = loadImage(picFile_buttonLvl3B);
  PImage button_Lvl3D = loadImage(picFile_buttonLvl3D);
  PImage button_Lvl3R = loadImage(picFile_buttonLvl3R);
  int x_button_Lvl3 = 300;
  int y_button_Lvl3 = 50;
  int w_button_Lvl3 = button_Lvl3B.width;
  int h_button_Lvl3 = button_Lvl3B.height;  
  button_Lvl3 = new ImageButtons(x_button_Lvl3, y_button_Lvl3, w_button_Lvl3, h_button_Lvl3, button_Lvl3B, button_Lvl3R, button_Lvl3D);
  
  PImage button_Lvl4B = loadImage(picFile_buttonLvl4B);
  PImage button_Lvl4D = loadImage(picFile_buttonLvl4D);
  PImage button_Lvl4R = loadImage(picFile_buttonLvl4R);
  int x_button_Lvl4 = 500;
  int y_button_Lvl4 = 200;
  int w_button_Lvl4 = button_Lvl4B.width;
  int h_button_Lvl4 = button_Lvl4B.height;  
  button_Lvl4 = new ImageButtons(x_button_Lvl4, y_button_Lvl4, w_button_Lvl4, h_button_Lvl4, button_Lvl4B, button_Lvl4R, button_Lvl4D);
  
  int x_button_Lvl5 = 680;
  int y_button_Lvl5 = 400;
  button_Lvl5 = new ImageButtons(x_button_Lvl5, y_button_Lvl5, w_button_Lvl4, h_button_Lvl4, button_Lvl4B, button_Lvl4R, button_Lvl4D);
  
  int x_button_Lvl6 = PApplet.parseInt(random(1) * 680);
  int y_button_Lvl6 = PApplet.parseInt(random(1) * 500);
  int w_button_Lvl6 = button_Lvl4B.width;
  int h_button_Lvl6 = button_Lvl4B.height;
  button_Lvl6 = new ImageButtons(x_button_Lvl6, y_button_Lvl6, w_button_Lvl6, h_button_Lvl6, button_Lvl4B, button_Lvl4R, button_Lvl4D);
  
  int x_button_Lvl7 = PApplet.parseInt(random(1) * 680);
  int y_button_Lvl7 = PApplet.parseInt(random(1) * 500);
  int w_button_Lvl7 = button_Lvl4B.width/100*70;
  int h_button_Lvl7 = button_Lvl4B.height/100*70;
  button_Lvl7 = new ImageButtons(x_button_Lvl7, y_button_Lvl7, w_button_Lvl7, h_button_Lvl7, button_Lvl4B, button_Lvl4R, button_Lvl4D);
  
  int x_button_Lvl8 = PApplet.parseInt(random(1) * 680);
  int y_button_Lvl8 = PApplet.parseInt(random(1) * 500);
  int w_button_Lvl8 = button_Lvl4B.width/100*40;
  int h_button_Lvl8 = button_Lvl4B.height/100*40;
  button_Lvl8 = new ImageButtons(x_button_Lvl8, y_button_Lvl8, w_button_Lvl8, h_button_Lvl8, button_Lvl4B, button_Lvl4R, button_Lvl4D);
  
  int x_button_Lvl9 = PApplet.parseInt(random(1) * 680);
  int y_button_Lvl9 = PApplet.parseInt(random(1) * 500);
  int w_button_Lvl9 = button_Lvl4B.width/100*20;
  int h_button_Lvl9 = button_Lvl4B.height/100*20;
  button_Lvl9 = new ImageButtons(x_button_Lvl9, y_button_Lvl9, w_button_Lvl9, h_button_Lvl9, button_Lvl4B, button_Lvl4R, button_Lvl4D);
}

public void draw() {
  if (dreamStatus == SCREEN_START) {
    if(!playerHaukotus.isPlaying()){
      playerHaukotus.play();
    }
    background(0);
    image(bkg_Start, 0, 0);
    image(bkg_Title, 0, 0);
    image(bkg_Help, 25, 530, 750, 66);
    button_Start.update();
    button_Start.display();
  }else if(dreamStatus == SCREEN_WIN){    
    if(playerHuohotus.isPlaying()){
      playerHuohotus.pause();
    }
    playerWakeup.play();
    image(bkg_Success, 0, 0);
    button_NextGame.update();
    button_NextGame.display();
  }else{
    if (millis() - milSecs > stepSeconds){ 
      dreamStatus = SCREEN_FAIL;      
      if(playerHuohotus.isPlaying()){
        playerHuohotus.pause();
      }      
      image(bkg_Fail, 0, 0);
      button_NewGame.update();
      button_NewGame.display();
    }else{
      if(playerHaukotus.isPlaying()){
        playerHaukotus.pause();
      }            
      if(!playerHuohotus.isPlaying()){
        playerHuohotus.loop();
        playerHuohotus.play();
      }
      if (dreamStatus == SCREEN_LVL1) {
        background(0);
        image(bkg_Lvl1, 0, 0);
        button_Lvl1.update();
        button_Lvl1.display();
      }
      if (dreamStatus == SCREEN_LVL2) {
        background(0);
        image(bkg_Lvl2, 0, 0);
        button_Lvl2.update();
        button_Lvl2.display();
      }
      if (dreamStatus == SCREEN_LVL3) {
        background(0);
        image(bkg_Lvl3, 0, 0);
        button_Lvl3.update();
        button_Lvl3.display();
      }
      if (dreamStatus == SCREEN_LVL4) {
        background(0);
        image(bkg_Lvl4, 0, 0);
        button_Lvl4.update();
        button_Lvl4.display();
      }
      if (dreamStatus == SCREEN_LVL5) {
        background(0);
        image(bkg_Lvl5, 0, 0);
        button_Lvl5.update();
        button_Lvl5.display();
      }
      if (dreamStatus == SCREEN_LVL6) {
        background(0);
        image(bkg_Lvl6, 0, 0);
        button_Lvl6.update();
        button_Lvl6.display();
      }
      if (dreamStatus == SCREEN_LVL7) {
        background(0);
        image(bkg_Lvl7, 0, 0);
        button_Lvl7.update();
        button_Lvl7.display();
      }
      if (dreamStatus == SCREEN_LVL8) {
        background(0);
        image(bkg_Lvl8, 0, 0);
        button_Lvl8.update();
        button_Lvl8.display();
      }
      if (dreamStatus == SCREEN_LVL9) {
        background(0);
        image(bkg_Lvl9, 0, 0);
        button_Lvl9.update();
        button_Lvl9.display();
      }
      textFont(fontti, 48);  
      text("They are " + ((stepSeconds/1000) -(millis() - milSecs)/1000) + " steps behind you!", 0, height-27);
      //text("" + stepSeconds + " -- " + (millis() - milSecs), 0, height-27);
    }
  }
}

public void stop(){
  playerHaukotus.close();
  playerHuohotus.close();
  minim.stop();
  super.stop();
}

public void mouseReleased() {
  int timeLeft = stepSeconds - (millis() - milSecs);
  println("timeLeft: " + timeLeft);
  if (dreamStatus == SCREEN_START && button_Start.over()) {
    dreamStatus = SCREEN_LVL1;
    milSecs = millis();
  }else if (dreamStatus == SCREEN_FAIL && button_NewGame.over()) {
    dreamStatus = SCREEN_LVL1;
    milSecs = millis();
    stepSeconds = lvl1MilSecs;
  }else if (dreamStatus == SCREEN_WIN && button_NextGame.over()) {
    dreamStatus = SCREEN_LVL1;
    milSecs = millis();
    stepSeconds = lvl1MilSecs;
  }else if(dreamStatus == SCREEN_LVL1 && button_Lvl1.over()) {   
    dreamStatus = SCREEN_LVL2;
    milSecs = millis();
    //stepSeconds += 3000;
    stepSeconds = timeLeft + 4000;
  }else if(dreamStatus == SCREEN_LVL2 && button_Lvl2.over()) {   
    dreamStatus = SCREEN_LVL3;
    milSecs = millis();
    stepSeconds = timeLeft + 3000;
  }else if(dreamStatus == SCREEN_LVL3 && button_Lvl3.over()) {   
    dreamStatus = SCREEN_LVL4;
    milSecs = millis();
    stepSeconds = timeLeft + 3000;
  }else if(dreamStatus == SCREEN_LVL4 && button_Lvl4.over()) {   
    dreamStatus = SCREEN_LVL5;
    milSecs = millis();
    stepSeconds = timeLeft + 3000;
  }else if(dreamStatus == SCREEN_LVL5 && button_Lvl5.over()) {   
    dreamStatus = SCREEN_LVL6;
    milSecs = millis();
    stepSeconds = timeLeft + 2000;
  }else if(dreamStatus == SCREEN_LVL6 && button_Lvl6.over()) {   
    dreamStatus = SCREEN_LVL7;
    milSecs = millis();
    stepSeconds = timeLeft + 2000;
  }else if(dreamStatus == SCREEN_LVL7 && button_Lvl7.over()) {   
    dreamStatus = SCREEN_LVL8;
    milSecs = millis();
    stepSeconds = timeLeft + 2000;
  }else if(dreamStatus == SCREEN_LVL8 && button_Lvl8.over()) {   
    dreamStatus = SCREEN_LVL9;
    milSecs = millis();
    stepSeconds += 1000;
  }else if(dreamStatus == SCREEN_LVL9 && button_Lvl9.over()) {   
    dreamStatus = SCREEN_WIN;
  }
  println("stepSeconds: " + stepSeconds);
}

// Classes
class Button
{
  int x, y;
  int w, h;
  int basecolor, highlightcolor;
  int currentcolor;
  boolean over = false;
  boolean pressed = false;   

  public boolean pressed() {
    if (over && mousePressed) {
      pressed = true;
    } 
    else {
      pressed = false;
    }    
    return pressed;
  }

  public boolean overRect(int x, int y, int width, int height) {
    if (mouseX >= x && mouseX <= x+width && 
      mouseY >= y && mouseY <= y+height) {
      return true;
    } 
    else {
      return false;
    }
  }
}

class ImageButtons extends Button 
{
  PImage base;
  PImage roll;
  PImage downs;
  PImage currentimage;

  ImageButtons(int ix, int iy, int iw, int ih, PImage ibase, PImage iroll, PImage idown) 
  {
    x = ix;
    y = iy;
    w = iw;
    h = ih;
    base = ibase;
    roll = iroll;
    downs = idown;
    currentimage = base;
  }

  public void update() 
  {
    over();
    pressed();
    if (pressed) {
      currentimage = downs;
    } 
    else if (over) {
      currentimage = roll;
    } 
    else {
      currentimage = base;
    }
  }

  public boolean over() 
  {
    if ( overRect(x, y, w, h) ) {
      over = true;
    } 
    else {
      over = false;
    }
    return over;
  }

  public void display() 
  {
    image(currentimage, x, y, w, h);
  }
}


  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "this_is_your_dream" });
  }
}
